// CalliGraph.cpp

#include "CalliGraph.h"						// Prototypes and constants
#include <stdio.h>
#include <math.h>
#include "resource.h"
#include "Grafo.h"
											//	Global  variable
HWND	winGraphHandle;						// Sockman window handle
HANDLE	hInstanceSockman;					// Sockman instance handle

HWND	winOutHandle;						// Sockman window handle
HANDLE	winOutInstance;	
char	winOutName[MAX_PRINT_BUFFER+1];
char	OutText[MAX_PRINT_BUFFER+1];

char	szAppName[9];						// Application name
char	szPrintBuffer[MAX_PRINT_BUFFER+1];	// Buffer for text to paint
int		Azione = IDM_EDIT_ADD_VERTEX;   
int		pesoArco;
bool    ActiveGrid=false;	


Grafo G(OrientatoNonPesato,"Knisberg");


POINTS	puntoStart,puntoStop;

int		Nvertice,Narco;

/****************** Proc di gestione finestra di output  ************/

long FAR PASCAL  OutWndProc(HWND hwnd, UINT iMessage, UINT wParam,
			LONG lParam)
{
	switch (iMessage)
		{ 
		case WM_CLOSE: 
			ShowWindow(winOutHandle ,SW_HIDE );

			return(0);
		case WM_LBUTTONDOWN: 
			
			return(0);		

		case WM_PAINT: 
			PAINTSTRUCT ps;
			
			RECT rect;
			HDC hdc;
			hdc = BeginPaint( hwnd, &ps);

			GetClientRect(winGraphHandle, &rect);
			SetTextColor(hdc,0);

			DrawText(hdc, OutText, -1, &rect,	DT_EXPANDTABS|DT_WORDBREAK);					
			G.paint(hdc);
			
			EndPaint(hwnd, &ps);
			return(0);

		}
return(DefWindowProc(hwnd, iMessage, wParam, lParam));
}



/****************** Proc di gestione finestra di input    ************/

BOOL CALLBACK PesoDialogProc(HWND hwndDlg, UINT iMessage, UINT wParam,LONG lParam)
{


switch(iMessage)
{
case  WM_INITDIALOG:

CenterWindow(hwndDlg);


return(TRUE);

case  WM_CLOSE:
	PostMessage(hwndDlg,WM_COMMAND,IDCANCEL,0L); // rimanda a cancel
	return(TRUE);

case WM_COMMAND:
	switch(wParam)
	{
	case IDOK:
		char StringaPeso[MAX_PRINT_BUFFER+1];
		GetDlgItemText(hwndDlg,IDC_EDIT_PESO,(LPSTR)StringaPeso,MAX_PRINT_BUFFER);
		pesoArco = atoi(StringaPeso);
		EndDialog(hwndDlg,TRUE);	
		return(TRUE);
	
	
	case IDCANCEL:
	EndDialog(hwndDlg,FALSE);	 
		return(TRUE);
	default :
		return(TRUE);
	}


}


return(TRUE);
	
}


void AddStartEdge(LONG lParam)
{
	// verifica che vi sia un vertice e centralo
	int i;
	POINTS punto = MAKEPOINTS(lParam);

if(   (i= G.SnapToVertex(punto,RAGGIO) ) >=0)		
{
	puntoStart = punto;
	strcpy(szPrintBuffer,"Selezionare il vertice di arrivo dell'arco");					
	InvalidateRect(winGraphHandle, NULL, false );
	UpdateWindow(winGraphHandle);
	Azione = IDM_EDIT_ADD_STOP_EDGE;
	
	}


}

void ReDrawEdge(LONG lParam)
{
	HPEN penna;
	HDC hdc;
    
	hdc = GetDC(winGraphHandle);
		
	penna= CreatePen( PS_DASH, 2, RGB(255,255,255) ) ;// cancello la vecchia linea
	HGDIOBJ temp =SelectObject(hdc,penna );	
	MoveToEx(hdc,puntoStart.x,puntoStart.y,NULL);
	if(puntoStop.x != puntoStop.y !=0)		// controllare meglio le coordinate valide
		LineTo(hdc,puntoStop.x,puntoStop.y);
	
	temp = SelectObject(hdc,temp );
	DeleteObject(penna);
//	BitBlt(GetDC( winGraphHandle) , puntoStart.x,puntoStart.y,abs(puntoStart.x-puntoStop.x),abs(puntoStart.y-puntoStop.x), BuffDC,0,0, MERGECOPY  );  
//	BitBlt( BuffDC, puntoStart.x,puntoStart.y,abs(puntoStart.x-puntoStop.x),abs(puntoStart.y-puntoStop.x), GetDC( winGraphHandle),0,0, MERGECOPY  );  
		

	puntoStop = MAKEPOINTS(lParam);
	// verifica che vi sia un vertice e centralo
	
	//InvalidateRect(winGraphHandle, NULL, TRUE);
	//UpdateWindow(winGraphHandle);

	
	
	penna= CreatePen( PS_DASH, 2, RGB(0,255,0) ) ;
	temp=SelectObject(hdc,penna); // riscrivo la nuova linea
	MoveToEx(hdc,puntoStart.x,puntoStart.y,NULL);
	
	LineTo(hdc,puntoStop.x,puntoStop.y);
	SelectObject(hdc,temp );
	DeleteObject(penna);

}


void AddStopEdge(LONG lParam)
{
	int i;
	POINTS	punto;


	punto = MAKEPOINTS(lParam);

	
	if(   (i= G.SnapToVertex(punto,RAGGIO)) >=0)
	{
	Azione = IDM_EDIT_ADD_START_EDGE;
	strcpy(szPrintBuffer,"Immettere il peso dell'arco");					
	
	InvalidateRect(winGraphHandle, NULL, TRUE);
	UpdateWindow(winGraphHandle);
	if(G.getTipo() & IDM_PESATO )  // se il grafo  pesato etichetto l'arco
		DialogBox(hInstanceSockman,MAKEINTRESOURCE( IDD_DIALOG_PESO),winGraphHandle,(DLGPROC)PesoDialogProc);
	else
		pesoArco=1;

	strcpy(szPrintBuffer,"Selezionare il vertice di partenza dell'arco");										
	G.add_edge(G.SnapToVertex(puntoStart,RAGGIO),i,pesoArco);
	}
	
	InvalidateRect(winGraphHandle, NULL, TRUE);
	UpdateWindow(winGraphHandle);
	



}


void AddVertex(LONG lParam)
{
	static int i;
	POINTS	punto,temp;
	COLORREF col;
	temp=punto = MAKEPOINTS(lParam);
	
	if(ActiveGrid == true)
	{
		if((temp.x % GRID) > GRID>>1)
			temp.x = (temp.x / GRID)*GRID+GRID;
		else
			temp.x = (temp.x / GRID)*GRID;		

		if((temp.y % GRID) > GRID>>1) 
		    temp.y = (temp.y / GRID)*GRID+GRID;		
		else
			temp.y = (temp.y / GRID)*GRID;		
				
	
	if(   i= G.SnapToVertex(temp,2*RAGGIO) >=0) // Verifica posizionamento lecito del vertice 
		temp=punto;
	else
		punto=temp;
	}

	if(   i= G.SnapToVertex(punto,2*RAGGIO) >=0) // Verifica posizionamento lecito del vertice
		
		return;									//  troppo vicini
	
		
	if(G.size_V() == 0)
		col=RGB(200,200,0);
	else col=RGB(0,0,0);

	Vertice *v = new Vertice (punto,col);	
	
	if(G.add_vertex(v)==false)
	{
		MessageBeep(0);
		MessageBox(winGraphHandle, "Impossibile aggiungere nuovo vertice !",
								szAppName, MB_ICONEXCLAMATION | MB_OK);
	}

	else v->paint(GetDC(winGraphHandle));



}
                    


int PASCAL WinMain(HANDLE	hInstance, HANDLE	hPrevInstance,
			LPSTR lpszCmdLine, int nCmdShow)
	{
		MSG msg ;
		WNDCLASS wndclass;
	        
		hInstanceSockman = hInstance;
		lstrcpy(szAppName, "CalliGraph"); // se cambio non mostra menu !?
		strcpy(szPrintBuffer,"Editare un grafo");


		if (!hPrevInstance) 
		{ 
				wndclass.style					= CS_HREDRAW | CS_VREDRAW;
				wndclass.lpfnWndProc		= WndProc;
				wndclass.cbClsExtra			= 0;
				wndclass.cbWndExtra			= 0;
				wndclass.hInstance			= hInstance;
				wndclass.hIcon					= LoadIcon(hInstance, szAppName);
				wndclass.hCursor				= LoadCursor(NULL, IDC_ARROW);
				wndclass.hbrBackground	= GetStockObject(WHITE_BRUSH);
				wndclass.lpszMenuName		= szAppName;
				wndclass.lpszClassName 	= szAppName;

				if (!RegisterClass(&wndclass))
					return FALSE;
			}


		winGraphHandle = CreateWindow
					(
						szAppName, 
						"CalliGraph Editor rev. 1",
						WS_OVERLAPPEDWINDOW,	//| WS_VSCROLL | WS_HSCROLL,
						CW_USEDEFAULT, 
						CW_USEDEFAULT,
						CW_USEDEFAULT, 
						CW_USEDEFAULT,
						NULL, 
						NULL, 
						hInstance, 
						NULL
					);


		if (!winGraphHandle)
			return FALSE;

			 			
					WNDCLASS  Outwndclass ;
					lstrcpy(winOutName, "winGraphOut"); /* inizializzazioni finestra di output   */
					
					Outwndclass.style			= CS_HREDRAW | CS_VREDRAW;			
					Outwndclass.lpfnWndProc		= OutWndProc;
					Outwndclass.cbClsExtra		= 0;
					Outwndclass.cbWndExtra		= 0;
					Outwndclass.hInstance		= winOutInstance;
					Outwndclass.hIcon			= NULL;//LoadIcon(hInstance, szAppName);
					Outwndclass.hCursor			= NULL;//LoadCursor(NULL, IDC_ARROW);
					Outwndclass.hbrBackground	= GetStockObject(WHITE_BRUSH);
					Outwndclass.lpszMenuName	= winOutName;
					Outwndclass.lpszClassName 	= winOutName;
					
					if (!RegisterClass(&Outwndclass))
						return FALSE;
					winOutHandle = CreateWindow
					(
						winOutName, 
						"Output Window",
						WS_OVERLAPPEDWINDOW,	//| WS_VSCROLL | WS_HSCROLL,
						CW_USEDEFAULT, 
						CW_USEDEFAULT,
						CW_USEDEFAULT, 
						CW_USEDEFAULT,
						NULL,//winGraphHandle, 
						NULL, 
						NULL,
						NULL
					);


					if (!winOutHandle)
						return FALSE;

				
		ShowWindow(winGraphHandle, nCmdShow);  // visualizzazione main window
		ShowOwnedPopups( winGraphHandle, TRUE);



		
			// inizializzazione menu 
		HMENU hmenu = GetMenu(winGraphHandle);
		if(( G.getTipo() &	IDM_ORIENTATO) == IDM_ORIENTATO)
		{
			CheckMenuItem(hmenu,IDM_NON_ORIENTATO,MF_UNCHECKED );
			CheckMenuItem(hmenu,IDM_ORIENTATO,MF_CHECKED );
		}
		else
		{
			CheckMenuItem(hmenu,IDM_NON_ORIENTATO,MF_CHECKED );
			CheckMenuItem(hmenu,IDM_ORIENTATO,MF_UNCHECKED );
		}
		
		if(G.getTipo() &	IDM_PESATO)
		{
			CheckMenuItem(hmenu,IDM_NON_PESATO,MF_UNCHECKED );
			CheckMenuItem(hmenu,IDM_PESATO,MF_CHECKED );
		}
		else
		{
			CheckMenuItem(hmenu,IDM_NON_PESATO,MF_CHECKED );
			CheckMenuItem(hmenu,IDM_PESATO,MF_UNCHECKED );
		}
	
		if(Azione == IDM_EDIT_ADD_VERTEX  )
		{
			CheckMenuItem(hmenu,IDM_EDIT_ADD_START_EDGE,MF_UNCHECKED );
			CheckMenuItem(hmenu,IDM_EDIT_ADD_VERTEX,MF_CHECKED );
		}
		else
		{
			CheckMenuItem(hmenu,IDM_EDIT_ADD_VERTEX,MF_UNCHECKED );
			CheckMenuItem(hmenu,IDM_EDIT_ADD_START_EDGE,MF_CHECKED );		
		}

					

 
		UpdateWindow(winGraphHandle);
		while(GetMessage(&msg, NULL, 0, 0))
					{
						TranslateMessage(&msg);
						DispatchMessage(&msg);
					}
			
		
		return(msg.wParam);
	}

	

long FAR PASCAL  WndProc(HWND hwnd, UINT iMessage, UINT wParam,
			LONG lParam)
	{
		switch (iMessage)
		{ 
		  HDC hdc;

				case WM_MOUSEMOVE :
					if (Azione == IDM_EDIT_ADD_STOP_EDGE && (wParam & MK_LBUTTON ) )
						ReDrawEdge( lParam);
					
					return(0);
				case WM_PAINT: 
					PAINTSTRUCT ps;
					HPEN penna;
					RECT rect;
				
					hdc = BeginPaint( hwnd, &ps);

					GetClientRect(winGraphHandle, &rect);
					SetTextColor(hdc,0);

					DrawText(hdc, szPrintBuffer, -1, &rect,
								DT_EXPANDTABS|DT_WORDBREAK);					
					
					penna=CreatePen( PS_DASH, SPESSORE_ARCO, RGB(100,10,10) ) ; 
					SelectObject(hdc,penna);
					//  chiamare edge iterator 
					G.paint(hdc);
					
					DeleteObject(penna);

					EndPaint(hwnd, &ps);
					return(0);



				case WM_LBUTTONDOWN: 
					
					if (Azione == IDM_EDIT_ADD_VERTEX)   
						AddVertex(lParam);
					else 
						if (Azione == IDM_EDIT_ADD_START_EDGE)
								AddStartEdge(lParam);			

					return(0);

				case WM_LBUTTONUP: 
					if (Azione == IDM_EDIT_ADD_STOP_EDGE)
						AddStopEdge(lParam);			
						
					return(0);
				
				case WM_COMMAND:
					if (DoMenuCommand(hwnd, iMessage, wParam, lParam))
						return(0);
					else
						break;
					
				case WM_DESTROY :
					PostQuitMessage(0);
					return(0) ;
			}
		
		return(DefWindowProc(hwnd, iMessage, wParam, lParam));
	}

long	DoMenuCommand(HWND hwnd, UINT iMessage, UINT wParam, LONG lParam)
	{
		switch (wParam)
			{
				case IDM_FILE_CLEAR:
					
					InvalidateRect(winGraphHandle, NULL, TRUE);
					UpdateWindow(winGraphHandle);
					return(TRUE);

				case IDM_NON_ORIENTATO:
					G.setTipo(IDM_NON_ORIENTATO);	
					CheckMenuItem(GetMenu(hwnd),IDM_NON_ORIENTATO,MF_CHECKED );
					CheckMenuItem(GetMenu(hwnd),IDM_ORIENTATO,MF_UNCHECKED );

					
					return(TRUE);
				
				case IDM_ORIENTATO:
					G.setTipo(IDM_ORIENTATO);					
					CheckMenuItem(GetMenu(hwnd),IDM_NON_ORIENTATO,MF_UNCHECKED );
					CheckMenuItem(GetMenu(hwnd),IDM_ORIENTATO,MF_CHECKED );
					
					return(TRUE);
				case IDM_NON_PESATO:
					G.setTipo(IDM_NON_PESATO);	
					CheckMenuItem(GetMenu(hwnd),IDM_NON_PESATO,MF_CHECKED );
					CheckMenuItem(GetMenu(hwnd),IDM_PESATO,MF_UNCHECKED );

					
					return(TRUE);
				
				case IDM_PESATO:
					G.setTipo(IDM_PESATO);					
					CheckMenuItem(GetMenu(hwnd),IDM_NON_PESATO,MF_UNCHECKED );
					CheckMenuItem(GetMenu(hwnd),IDM_PESATO,MF_CHECKED );
					
					return(TRUE);


				case IDM_FILE_PRINT:
				case IDM_FILE_SAVEAS:
					PaintWindow((LPSTR) "File functions are not yet implemented!");
					MessageBeep(0);
					MessageBox(hwnd, "File functions are not yet implemented!",
								szAppName, MB_ICONEXCLAMATION | MB_OK);
					return(TRUE);
				case IDM_EDIT_ADD_VERTEX:
					strcpy(szPrintBuffer,"Aggiungi nuovo vertice");					
					InvalidateRect(winGraphHandle, NULL, TRUE);
					UpdateWindow(winGraphHandle);
					CheckMenuItem(GetMenu(hwnd),IDM_EDIT_ADD_START_EDGE,MF_UNCHECKED );
					CheckMenuItem(GetMenu(hwnd),IDM_EDIT_ADD_VERTEX,MF_CHECKED );

					Azione=IDM_EDIT_ADD_VERTEX;

					return(TRUE);
				
				case IDM_EDIT_ADD_START_EDGE:
					strcpy(szPrintBuffer,"Selezionare il vertice di partenza dell'arco");					
					InvalidateRect(winGraphHandle, NULL, TRUE);
					UpdateWindow(winGraphHandle);
					Azione=IDM_EDIT_ADD_START_EDGE;
					CheckMenuItem(GetMenu(hwnd),IDM_EDIT_ADD_VERTEX,MF_UNCHECKED );
					CheckMenuItem(GetMenu(hwnd),IDM_EDIT_ADD_START_EDGE,MF_CHECKED );		
					
					return(TRUE);
				
				case IDM_COMPLETA_GRAFO:
					int j,i;					
					for( j =0; j< G.size_V();j++)
						for( i =0; i< G.size_V();i++)
						{
						G.add_edge(i,j,1);
						G.add_edge(j,i,1);
						}
						InvalidateRect(winGraphHandle, NULL, FALSE);
						UpdateWindow(winGraphHandle);					
										
					return (TRUE);

				case IDM_EDIT_ACTIVE_GRID:
				
					 if(ActiveGrid==true)
					 {	
						 ActiveGrid=false;
						 CheckMenuItem(GetMenu(hwnd),IDM_EDIT_ACTIVE_GRID,MF_UNCHECKED );					
					 }
					 else
					 {
						 ActiveGrid=true;
						 CheckMenuItem(GetMenu(hwnd),IDM_EDIT_ACTIVE_GRID,MF_CHECKED );					
					 }
										
					return (TRUE);

				case IDM_FILE_EXIT:
					SendMessage(hwnd, WM_CLOSE, 0, 0L);
					return(TRUE);
		
				case IDM_HELP_HELP:
					MessageBeep(0);
					MessageBox(hwnd, "Help is not yet implemented!", szAppName,
								MB_ICONEXCLAMATION | MB_OK);
					return(TRUE);
		
				case IDM_HELP_ABOUT:
					MessageBox(hwnd,
								"EdiTour di grafi",
								"CalliGraph rev. 1 By Cascio Vittorio", 
								MB_ICONINFORMATION | MB_OK);
					return(TRUE);
		
				default:
					return(DoGraphProgram(hwnd, wParam, lParam));
			}
	}

long DoGraphProgram(HWND hwnd, UINT wParam, LONG lParam)
	{
		switch (wParam)
			{
				case IDM_APP_BFS:
					{
					HDC BuffDC = CreateCompatibleDC( GetDC( winGraphHandle) ); 
					HPEN penna=CreatePen( PS_SOLID, 6, RGB(255,30,120) ) ; 
					SelectObject(BuffDC,penna);
					SelectObject(GetDC( winGraphHandle),penna);
	
					Ellipse(BuffDC,10,10,50,50);
				//	Ellipse(GetDC( winGraphHandle),20,20,50,50);
				//	Ellipse(GetDC( winGraphHandle),120,120,150,150);

					
if (BitBlt(GetDC( winGraphHandle) , 1,1,100,100, BuffDC,1,1, SRCCOPY   ) == 0)
{
	LPVOID lpMsgBuf;

FormatMessage( 
    FORMAT_MESSAGE_ALLOCATE_BUFFER | FORMAT_MESSAGE_FROM_SYSTEM,
    NULL,
    GetLastError(),
    MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT), // Default language
    (LPTSTR) &lpMsgBuf,
    0,
    NULL 
);

// Display the string.
MessageBox( NULL, (char *)lpMsgBuf, "GetLastError", MB_OK|MB_ICONINFORMATION );

// Free the buffer.
LocalFree( lpMsgBuf );
 
}
InvalidateRect(winGraphHandle, NULL, TRUE);
UpdateWindow(winGraphHandle);

  
//	BitBlt( BuffDC, puntoStart.x,puntoStart.y,abs(puntoStart.x-puntoStop.x),abs(puntoStart.y-puntoStop.x), GetDC( winGraphHandle),0,0, MERGECOPY  );  
					MessageBeep(0);
					MessageBox(hwnd, "No APPLICATIONS are currently implemented!",
								szAppName, MB_ICONEXCLAMATION | MB_OK);	


					}
					
					return(TRUE);
				case IDM_APP_INFO:
					MessageBeep(0);
					char sztempBuffer[MAX_PRINT_BUFFER+1];					// Buffer for text to paint
					
					sprintf(sztempBuffer,"Orientato\t%s\nPesato\t%s\nVertici\t%2d\nArchi\t%2d",
								(G.is_Orientato())?"SI":"NO",
								(G.is_Pesato())?"SI":"NO",
								 G.size_V(),G.size_E() );
					MessageBox(hwnd, sztempBuffer,
								G.name(), MB_ICONINFORMATION    | MB_OK);
					
					return(TRUE);
				case IDM_APP_BELLFORD:
					if(G.Bellmann_Ford())
					{
						ShowWindow(winOutHandle ,SW_SHOW ); 					
						G.paint(GetDC(winOutHandle));
					}
					else {
						char sztempBuffer[MAX_PRINT_BUFFER+1];					// Buffer for text to paint
					
						sprintf(sztempBuffer,"Esistono cicli negativi !" );
						MessageBox(hwnd, sztempBuffer,
								G.name(), MB_ICONINFORMATION    | MB_OK);
						}

					return(TRUE);
				case IDM_APP_COLORABILITA:
					
					{
					int k=1;
					while (k< 12)
					{
					G.init_Colorazione();
					if(G.Colorazione(0,k))
						{
						//ShowWindow(winOutHandle ,SW_SHOW ); 
						//Grafo Gout= G;
						//G.paint(GetDC(winOutHandle));				
						G.paint(GetDC(hwnd));				
						sprintf(sztempBuffer,"Il Grafo  colorabile con %d color%c",k,(k>1)?'':'e' );
						MessageBox(winOutHandle, sztempBuffer,
								G.name(), MB_ICONINFORMATION    | MB_OK);
						return(TRUE);	
						}
						else
						{
							G.paint(GetDC(hwnd));				
							k++;
						}
					}
					sprintf(sztempBuffer,"Il Grafo non  colorabile con %d colori",k );
						MessageBox(hwnd, sztempBuffer,
								G.name(), MB_ICONINFORMATION    | MB_OK);
					}							
					return(TRUE);	

				case ID_APP_CLIQUE:
					{
					int k=G.size_V();
					
					while (k)
						{
						G.init_Cricca();
						if(G.enCricca(0,0,k))
							{
							//ShowWindow(winOutHandle ,SW_SHOW ); 
							//Grafo Gout= G;
							//G.paint(GetDC(winOutHandle));				
							G.paint(GetDC(hwnd));				
							sprintf(sztempBuffer,"Il Grafo contiene una clique di %d vertic%c",k,(k>1)?'':'e' );
							MessageBox(winOutHandle, sztempBuffer,
									G.name(), MB_ICONINFORMATION    | MB_OK);
							return(TRUE);	
							}
							else
							{
								G.paint(GetDC(hwnd));				
								k--;
							}
						}
					}							
					
					return(TRUE);

				case IDM_APP_DFS:

					ShowWindow(winOutHandle ,SW_SHOW ); 
					Grafo Gout= G;
					G.DFS( winOutHandle );
					G.paint(GetDC(winOutHandle));				
					//Gout.DFS( winOutHandle );
					//Gout.paint(GetDC(winOutHandle));				

					return(TRUE);

				
			}
		return(FALSE);
	}







